import java.io.*;

public class NVTInputStream extends FilterInputStream
{
	byte IAC = (byte) 0xff;
	byte DO = (byte) 0xfd;
	byte WILL = (byte) 0xfb;
	byte CR = 13;
	byte LF = 10;
	int WONT = 252;
	int DONT = 254;
	int BUFFER_SIZE = 1024;
	OutputStream out;
	byte lineBuffer[] = new byte[BUFFER_SIZE];
	int numBytes = 0;
	
	public NVTInputStream(InputStream inStream,OutputStream outStream)
	{
    	super(inStream);
        out = outStream;
    }
 
    public int read() throws IOException
    {
    	boolean recIAC;
        int i;
        do
        {
        	recIAC = false;
	        i = in.read();
            if(i == -1) return i;
        	byte b = (byte) i;
            if(b == IAC)
            {
            	recIAC = true;
                int cmd = in.read();
                if(cmd == -1) return cmd;
                byte b2 = (byte) cmd;
                if(b2 == IAC) return 255;
           		else if(b2 == DO)
	            {
	             	int opt = in.read();
	                if(opt == -1) return opt;
	                out.write(255);
	                out.write(WONT);
	                out.write(opt);
	                out.flush();
	            }else if(b2 == WILL) {
	            	int opt = in.read();
	                if(opt == -1) return opt;
	                out.write(255);
	                out.write(DONT);
	                out.write(opt);
	                out.flush();
	          	}
	      	}
	 	} while(recIAC);

        return i;
	}
    
    public String readLine() throws IOException
    {
    	numBytes = 0;				// no. bytes in this line
  		boolean finished = false;	
 		do
 		{
  			int i = read();				// get character from stream
           	if(i == -1) return null;	// if bad return
         	byte b = (byte) i;			// make it a byte
         	if(b == LF)					// if it's an lf
          	{
            	if(numBytes>0)			// if there's some characters not just a linefeed
	           	{
 					if(lineBuffer[numBytes-1] == CR) 	// return buffer (apart from this char. cos it's an lf) as string if 2nd last is a CR
                	return new String (lineBuffer,0,numBytes);
                }
          	}
         	lineBuffer[numBytes] = b;	// it's not an LF, add it to the buffer
   			++numBytes;					// inc. counter
 		} while (!finished);
      	return null;
 	}
}
