/*
		Chameleon: Integrated System Exploration Environment
		Iain C (Fell)	                         Nov, Dec 98
*/

import java.net.*;
import java.io.*;
import java.util.*;

public class chameleonScanner
{
	public static scannerForm theForm	= null;	// The form
	public static int noOfThreads		= 0;	// Number of threads currently running
	public static PortTalk newTelnetClient  = null;	// The telnet client

	public static void main(String args[])
	{
    	theForm = new scannerForm();	// Set up the form
 	    theForm.log.append("*** Welcome to Chameleon ***\nIntegrated System Exploration Environment\nCoded by Fell, Winter '98\nReady\n");
	}
	
	public static void performGABNLookup()	// To do a getAllByName check on target
	{
		try
		{
			disableControls();
			String domain = theForm.target.getText();
			theForm.status.setText("Status: Peer list lookup on " + domain);

			InetAddress[] machines = InetAddress.getAllByName(domain);

			theForm.log.append("* There are " + machines.length + " machines in " + domain + "\n");

			for (int i=0; i<machines.length; i++)
			{
				theForm.log.append("	Name: " + machines[i].getHostName() + " IP Address: " + machines[i].getHostAddress() + "\n");
			}

			enableControls();
		}
		catch (UnknownHostException e)
		{
			theForm.log.append("Error: Unknown host\n");
			theForm.status.setText("Status: Offline");
			enableControls();
		}
	}

	public static String performDNSLookup(String name) // To convert a name string to an ip number
	{
		try
		{
			disableControls();
			theForm.status.setText("Status: DNS lookup on " + name);
			InetAddress convertMe = InetAddress.getByName(name);
			String IPNumber = convertMe.getHostAddress();
			theForm.status.setText("Status: Offline");
			enableControls();
			return(IPNumber);
		} catch (UnknownHostException e) {
			theForm.log.append("Error: " + name + ": Unknown host\n");
			theForm.status.setText("Status: Offline");
			enableControls();
			return(name);
		}
	}
	
	public static void doTelnet()	// Open a telnet client
	{
		theForm.log.append("* Starting telnet session...\n");

		String machine = theForm.target.getText();
		int port = Integer.parseInt(theForm.telnetPort.getText());
		
		newTelnetClient = new PortTalk(machine, port);
		newTelnetClient.start();
	}
	
	public static void scanClassC()	// Scan a subnet
	{
		disableControls();
		
		if (theForm.chkScanRange.getState()) scanRangeClassC();
		else if (theForm.chkScanSelected.getState()) scanSelectedClassC();
		
		theForm.log.append("* Done\n");
		theForm.status.setText("Status: Offline");
		enableControls();
	}
	
	public static void scanSingle()	// Scan a single IP
	{
		disableControls();
		
        	if (theForm.chkScanRange.getState()) scanRangeSingle();
		else if (theForm.chkScanSelected.getState()) scanSelectedSingle();

		theForm.log.append("* Done\n");
		theForm.status.setText("Status: Offline");
		enableControls();
	}

	public static void scanRandom()	// Scan random IPs
	{
		disableControls();
		theForm.log.append("* Starting random IP scan...\n");

		while (true)	// Amend this to "until user hits STOP" when stop button implemented...
		{
			// Generate a random IP, put it in theForm.target, scan it!

			Random IPGenerator = new Random();

			int w = (IPGenerator.nextInt()/10000000);			// This mess is the quickest
			int x = (IPGenerator.nextInt()/10000000);			// way I could find of generating
			int y = (IPGenerator.nextInt()/10000000);			// random numbers, 0 to 255, with
			int z = (IPGenerator.nextInt()/10000000);			// the Random() class.
											// Oh well... not best elegant
			while (w<0 || w>255) {w = (IPGenerator.nextInt()/10000000);}	// but it works OK.
			while (x<0 || x>255) {x = (IPGenerator.nextInt()/10000000);}	//
			while (y<0 || y>255) {y = (IPGenerator.nextInt()/10000000);}	//
			while (z<0 || z>255) {z = (IPGenerator.nextInt()/10000000);}	//
			
			String newIP = Integer.toString(w) + "." + Integer.toString(x) + "." + Integer.toString(y) + "." + Integer.toString(z);
			theForm.target.setText(newIP);			

	        	if (theForm.chkScanRange.getState()) scanRangeSingle();
			else if (theForm.chkScanSelected.getState()) scanSelectedSingle();
		}

		//theForm.log.append("* Done\n");		// These never reached... amend when STOP mechanism implemented.
		//theForm.status.setText("Status: Offline");
		//enableControls();
	}

	public static void scanFile()	// Scan a target file of IPs or names
	{
		disableControls();
		theForm.log.append("* Starting scan from target file...\n");
	       	theForm.status.setText("Status: Loading and parsing target file (TARGETS.CMN) - Please wait");
		
		try // To do all my file shit
		{

			BufferedReader fileIn = new BufferedReader (new FileReader("targets.cmn"));
			theForm.status.setText("Status: Ready to start file scan");

			String line = null;

			while ((line=fileIn.readLine())!=null)	// Amend this to "until user hits STOP" when stop button implemented...
			{
				// Loop through file scanning each IP (one per line)
				theForm.target.setText(line);

		        	if (theForm.chkScanRange.getState()) scanRangeSingle();
				else if (theForm.chkScanSelected.getState()) scanSelectedSingle();
			}

			fileIn.close();

		} catch (FileNotFoundException e) {
			theForm.log.append("Error: FILE 'TARGETS.CMN' NOT FOUND:");
			theForm.log.append("  Make sure it's in the same path as Chameleon.");
		} catch (IOException e) {
			theForm.log.append("Error: ERROR READING FROM FILE 'TARGETS.CMN':");
			theForm.log.append("  Make sure it's a list of IP numbers or hostnames,");
			theForm.log.append("  one per line, normal ASCII file.");
		}

		theForm.log.append("* Done\n");
		theForm.status.setText("Status: Offline");
		enableControls();
	}

	static void waitForSpace()	// To ensure scanner doesn't open too many threads
	{
		while (noOfThreads>Integer.parseInt(theForm.maxThreads.getText())){}
	}
	
	static void disableControls()	// To disable controls (apart from cmdStop, which it enables)
	{
		theForm.cmdScanSingle.setEnabled(false);
		theForm.cmdScanC.setEnabled(false);
		theForm.cmdDNS.setEnabled(false);
		// theForm.cmdStop.setEnabled(true); // Deactivated: Reinstate when STOP implemented
		theForm.chkListen.setEnabled(false);
		theForm.target.setEnabled(false);
		theForm.subnetStart.setEnabled(false);
		theForm.subnetEnd.setEnabled(false);
		theForm.portStart.setEnabled(false);
		theForm.portEnd.setEnabled(false);
		theForm.chkScanSelected.setEnabled(false);
		theForm.chkScanRange.setEnabled(false);
		theForm.chkListen.setEnabled(false);
		theForm.timeout.setEnabled(false);
		theForm.linesToReceive.setEnabled(false);
		theForm.portList.setEnabled(false);
		theForm.maxThreads.setEnabled(false);
		theForm.telnetPort.setEnabled(false);
		theForm.cmdTelnet.setEnabled(false);
		theForm.cmdPing.setEnabled(false);
		theForm.pingTimeout.setEnabled(false);
		theForm.pingCount.setEnabled(false);
		theForm.pingBytes.setEnabled(false);
		theForm.cmdFinger.setEnabled(false);
		theForm.userToFinger.setEnabled(false);
		theForm.cmdGABN.setEnabled(false);
		theForm.chkPortLibrary.setEnabled(false);
		theForm.cmdScanRandom.setEnabled(false);
		theForm.cmdScanFile.setEnabled(false);
		theForm.portToGuard.setEnabled(false);
		theForm.cmdPortGuard.setEnabled(false);
		theForm.cmdAddItem.setEnabled(false);
		theForm.itemToAdd.setEnabled(false);
		theForm.cmdExportLog.setEnabled(false);
		theForm.cmdSelectAll.setEnabled(false);
	}

	static void enableControls()	// To enable controls (apart from cmdStop, which it disables)
	{
		theForm.cmdScanSingle.setEnabled(true);
		theForm.cmdScanC.setEnabled(true);
		theForm.cmdDNS.setEnabled(true);
		// theForm.cmdStop.setEnabled(false); // Deactivated: Reinstate when STOP implemented
		theForm.chkListen.setEnabled(true);
		theForm.target.setEnabled(true);
		theForm.subnetStart.setEnabled(true);
		theForm.subnetEnd.setEnabled(true);
		theForm.portStart.setEnabled(true);
		theForm.portEnd.setEnabled(true);
		theForm.chkScanSelected.setEnabled(true);
		theForm.chkScanRange.setEnabled(true);
		theForm.chkListen.setEnabled(true);
		theForm.timeout.setEnabled(true);
		theForm.linesToReceive.setEnabled(true);
		theForm.portList.setEnabled(true);
		theForm.maxThreads.setEnabled(true);
		theForm.telnetPort.setEnabled(true);
		theForm.cmdTelnet.setEnabled(true);
		theForm.cmdPing.setEnabled(true);
		theForm.pingTimeout.setEnabled(true);
		theForm.pingCount.setEnabled(true);
		theForm.pingBytes.setEnabled(true);
		theForm.cmdFinger.setEnabled(true);
		theForm.userToFinger.setEnabled(true);
		theForm.cmdGABN.setEnabled(true);
		theForm.chkPortLibrary.setEnabled(true);
		theForm.cmdScanRandom.setEnabled(true);
		theForm.cmdScanFile.setEnabled(true);
		theForm.portToGuard.setEnabled(true);
		theForm.cmdPortGuard.setEnabled(true);
		theForm.cmdAddItem.setEnabled(true);
		theForm.itemToAdd.setEnabled(true);
		theForm.cmdExportLog.setEnabled(true);
		theForm.cmdSelectAll.setEnabled(true);
	}
	
	public static void scan(InetAddress machine, int port)	// Start a new scan thread for one port
	{
		waitForSpace();
		scanThread thread = new scanThread (machine, port, theForm.chkListen.getState(), Integer.parseInt(theForm.linesToReceive.getText()), Integer.parseInt(theForm.timeout.getText()), theForm.chkPortLibrary.getState());
		thread.start();
	}
	
	static void scanSelectedClassC()	// Scan selected ports across the subnet
	{
		theForm.target.setText(performDNSLookup(theForm.target.getText())); // Convert to numbers

		int startAddress = Integer.parseInt(theForm.subnetStart.getText());
		int endAddress = Integer.parseInt(theForm.subnetEnd.getText());

		theForm.log.append("* Trying selected ports across subnet " + startAddress + "-" + endAddress + "\n");

		// Now get the first three components of the dot-seperated IP number
		StringTokenizer st1 = new StringTokenizer(theForm.target.getText(),".");
		String targetSubnet = st1.nextToken() + "." + st1.nextToken() + "." + st1.nextToken() + ".";
			
		// Get selected ports as array of Strings
		String ports[] = theForm.portList.getSelectedItems();
				
		// Reformat them into an array of ints containing the port numbers
		int[] portNumbers = new int[ports.length];
				
		for (int i=0; i!=ports.length; i++)
		{
			StringTokenizer st = new StringTokenizer(ports[i]);
			String thePort = st.nextToken();
			portNumbers[i]=Integer.parseInt(thePort);
		}
			
		// Now step through the subnet scanning selected ports of each machine in subnet range
		for (int currentAddress=startAddress; currentAddress<=endAddress; currentAddress++)
		{
			String target = targetSubnet + currentAddress;
			try
			{
				InetAddress machine = InetAddress.getByName(target);

				theForm.log.append("* Trying " + machine.getHostName() + "\n");
					
				// Step through portNumbers scanning each.
				for (int i=0; i!=portNumbers.length; i++)
				{
					int currentPort = portNumbers[i];
					theForm.status.setText("Status: Scanning " + machine.getHostName() + " : " + currentPort);
					scan(machine, currentPort);
				}
					
				theForm.status.setText("Status: Next machine...");
	
			} catch (UnknownHostException e) {
				theForm.log.append("Error: " + theForm.target.getText() + ": Unknown host\n");
			}
		}
	}
	
	static void scanRangeClassC()	// Scan a range of ports across the subnet

	{
		theForm.target.setText(performDNSLookup(theForm.target.getText())); // Convert to numbers
		
		int startPort = Integer.parseInt(theForm.portStart.getText());
		int endPort = Integer.parseInt(theForm.portEnd.getText());			
		int startAddress = Integer.parseInt(theForm.subnetStart.getText());
		int endAddress = Integer.parseInt(theForm.subnetEnd.getText());

		theForm.log.append("* Trying range " + startPort + "-" + endPort + " across subnet " + startAddress + "-" + endAddress + "\n");

		// Now get the first three components of the dot-seperated IP number
		StringTokenizer st = new StringTokenizer(theForm.target.getText(),".");
		String targetSubnet = st.nextToken() + "." + st.nextToken() + "." + st.nextToken() + ".";
			
		// Now step through the subnet scanning port range of each machine in subnet range
		for (int currentAddress=startAddress; currentAddress<=endAddress; currentAddress++)
		{
			String target = targetSubnet + currentAddress;
			try
			{
				InetAddress machine = InetAddress.getByName(target);

				theForm.log.append("* Trying " + machine.getHostName() + "\n");
				for (int currentPort=startPort; currentPort<=endPort; currentPort++)
				{
					theForm.status.setText("Status: Scanning " + machine.getHostName() + " : " + currentPort);
					scan(machine, currentPort);
				}
				theForm.status.setText("Status: Next machine...");			
			} catch (UnknownHostException e) {
				theForm.log.append("Error: " + theForm.target.getText() + ": Unknown host\n");
			}
		}
	}

	static void scanRangeSingle()	// Scan a range of ports on one machine
	{
		// Set up InetAddress using theForm.target, step through port range calling scan (machine, port) on each
		try{
			InetAddress machine = InetAddress.getByName(theForm.target.getText());
			int startPort = Integer.parseInt(theForm.portStart.getText());
			int endPort = Integer.parseInt(theForm.portEnd.getText());
			theForm.log.append("* Trying range " + startPort + "-" + endPort + " on " + machine.getHostName() + "\n");
			for (int currentPort=startPort; currentPort<=endPort; currentPort++)
			{
				theForm.status.setText("Status: Scanning " + machine.getHostName() + " : " + currentPort);
				scan(machine, currentPort);
			}
			theForm.status.setText("Status: Offline");			
		} catch (UnknownHostException e) {
			theForm.log.append("Error: " + theForm.target.getText() + ": Unknown host\n");
		}
	}

	static void scanSelectedSingle()	// Scan selected ports on one machine
	{
		// Set up InetAddress using theForm.target, step through selected ports calling scan (machine, port) on each
		try{
			InetAddress machine = InetAddress.getByName(theForm.target.getText());
				
			// Get selected ports as array of Strings
			String ports[] = theForm.portList.getSelectedItems();
				
			// Reformat them into an array of ints containing the port numbers
			int[] portNumbers = new int[ports.length];
				
			for (int i=0; i!=ports.length; i++)
			{
				StringTokenizer st = new StringTokenizer(ports[i]);
				String thePort = st.nextToken();
				portNumbers[i]=Integer.parseInt(thePort);
			}
				
			theForm.log.append("* Trying selected on " + machine.getHostName() + "\n");
			
			// Now step through portNumbers scanning each.
			for (int i=0; i!=portNumbers.length; i++)
			{
				int currentPort = portNumbers[i];
				theForm.status.setText("Status: Scanning " + machine.getHostName() + " : " + currentPort);
				scan(machine, currentPort);
			}
		} catch (UnknownHostException e) {
			theForm.log.append("Error: " + theForm.target.getText() + ": Unknown host\n");
		}
	}
}
