import java.net.*;
import java.io.*;
import java.util.StringTokenizer; // just this so ambuguity with awt List isn't created
import java.awt.*;

public class scanThread extends Thread
{
  
  InetAddress	machine = null;	// remote machine
  int			port 	= 0;	// remote port
  boolean		listen	= true;	// listen to port if connected?
  int			lines	= 0; 	// no. of lines to receive for
  int			timeOut	= 0; 	// timeout on listen
  boolean       library = true;    // use port library if connected?
  
  public scanThread(InetAddress _machine, int _port, boolean _listen, int _lines, int _timeOut, boolean _library)
  {
		machine = _machine;
		port   = _port;
		listen	= _listen;
		lines	= _lines;
		timeOut = _timeOut;
		library = _library;
  }

  public void run()
  {
		countMeIn();	// register me in noOfThreads
	    try
	   	{
	       	Socket s = new Socket(machine, port);	// open the socket: jumps to catch if no listener on this port
	       	String hostname = machine.getHostName();// get host name
	        chameleonScanner.theForm.log.append("* Open: " + port + " on " + hostname + "\n"); // Log it
	        if (library) chameleonScanner.theForm.log.append("* Port library info on " + port + ": " + getPortInfo(port) + "\n");
	        if (listen)
	        {
		        // Try for a listen...
		        s.setSoTimeout(timeOut); // set timeout
		        BufferedReader in  = new BufferedReader(new InputStreamReader(s.getInputStream())); // new input stream
		        try { // to get some lines in
		        	for (int i=0; i!=lines; i++) {
			        	String incoming = in.readLine();
	    	    		chameleonScanner.theForm.log.append("* Rx from " + port + ": " + incoming + "\n"); // Log it
		    	    }
		     	} catch (IOException e) { // Probably just a timeout. Don't log it, just abandon the listen.
				}
			}
	       	s.close();
	    }
	    catch (IOException e) {
	    // Nothing listening
	    }
		countMeOut();	// remove me from noOfThreads
  }
  
  synchronized void countMeIn() {
	chameleonScanner.noOfThreads=chameleonScanner.noOfThreads+1;
  }
  
  synchronized void countMeOut() {
	chameleonScanner.noOfThreads=chameleonScanner.noOfThreads-1;
  }
  
  synchronized String getPortInfo(int currentPort) // To check port number against library
  {
	// Get a copy of the list
  	List portList = chameleonScanner.theForm.portList;
  	
	// Get all items as array of Strings
	String ports[] = portList.getItems();
  	int noOfEntries = ports.length;
	
	// step through ports[] comparing currentPort to the first token of each entry in the library
  	for (int i=0; i!=noOfEntries; i++)
  	{
  		StringTokenizer st = new StringTokenizer(ports[i]);
		String port = st.nextToken();
		int portInEntry = Integer.parseInt(port);
		
		
		if (portInEntry == currentPort)
		{
			// return the info on this port
			String eatMe = st.nextToken(); // Don't need this one (it's a "-")
			String portInfo = "";
			while (st.hasMoreTokens())
			{
			    portInfo = portInfo + " " + st.nextToken();
			}
			return(portInfo);	
		}
	}
	
	// no info on this port
	return ("(no info)");
  }
}
